// ppdoswind.cpp      PURRPUSS                        jha: 8aug98-24jly01
//
#include "c:\Program Files\Borland\CBuilder3\Examples\foodrink\Ppheader.hpp"

struct robot_info* sa = new robot_info;
struct robot_info* sb = new robot_info;
struct robot_info* s =  sa;             // GLOBAL PP ENTITY POINTER
struct pp_info* pp = new pp_info;
struct world w = *new world;               // CONTAINS OR REFERS TO ALL DATA

extern TWindFile	*wf;

//
// =====================================================================

short      	windowNumber = 0;
short			windowOR = 0;
const short	WBUFLENGTH  = 256;
const short	SAFEBUFLENGTH	= 1000; //Used for truncating to window buf length
const short	BIGBUFLENGTH	= 10000; //Used for holding info to go to file
const short BIGBUFTHRESHOLD = BIGBUFLENGTH - WBUFLENGTH;
ofstream 	outfile;
ifstream 	infile;

// ====================================================================
 TWindFile::TWindFile()
  { File = new fileNames;
	 if (!File) error("No space for fileNames.");
//	 Buf  = new buffers;
//	 if (!Buf) error("No space for buffers.");
	 wBuf = new char[WBUFLENGTH];
	 if (!wBuf) error("No space for wBuf.");
	 bigBuf = new char[BIGBUFLENGTH];
	 if (!bigBuf) error("No space for bigBuf.");
	 mainFileCount = 0;
	 bigBufCount = 0;
	 maxStepsInFile = 100;
  }

void TWindFile::ChangeMainFile()
{ sprintf(File->Main,
 "d:\\ppdata\\foodrink\\%c%c%d.dat", w.filechar,w.filechar,mainFileCount);
  outfile.open(File->Main); outfile.close();
}

void TWindFile::CopyBufToBigBuf(char* buf)
{ strcat(bigBuf, buf);
  bigBufCount += strlen(buf);
  if (( bigBufCount > BIGBUFTHRESHOLD ) || ( !w.jumping ))
	 {CopyBufToFile(File->Main, bigBuf);
	  bigBufCount = 0;
	  bigBuf[0] = '\0';
	 }
}

void TWindFile::CopyBigBufToFile()
{ if ( bigBufCount > 0 )
	 {CopyBufToFile(File->Main, bigBuf);
	  bigBufCount = 0;
	  bigBuf[0] = '\0';
	 }
}

void TWindFile::CopyBufToFile(char* filename, char* buf)
 { outfile.open(filename, ios::app);
	 if (!outfile) {cout << "Fails to Copy to File" << endl;
									  getch(); exit(-1);
				   }
	 else outfile << buf;
	 outfile.close();
 }

// Copies buf to file but appends buf to display buffer for windows 0 & 2.
void TWindFile::DisplayAndFile(char *buf, short wNumber)
{ windowNumber = wNumber; // Display will await painting at end of function
  switch (wNumber)
	{case 0 : if (w.no_display_or_file) return;
			  if (w.diag) CopyBufToFile(File->Main, buf);
			  else CopyBufToBigBuf(buf);     // 4sep99 to increase speed
// 				 if (!w.jumping)
			  cout << buf;
//  			     else buf[0] = '\0';
			  return;
	 case 2 : if (w.no_display_or_file) return;
			  if (w.diag) CopyBufToFile(File->Main, buf);
			  else CopyBufToBigBuf(buf);     // 4sep99 to increase speed
			  if (!w.jumping) cout << buf;
//  			     else buf[0] = '\0';
			  return;
	 case 1 : //if (!((w.jumping) && (w.min_file_record_while_jumping)))
				 //	{if (w.diag) CopyBufToFile(File->Main, buf);
				 //	 else CopyBufToBigBuf(buf);     // 4sep99 to increase speed
				 //	}
//                 clrscr();
				 cout << buf;
				 return;
	 default: cout << buf;
			  CopyBufToFile(File->Main, buf);
			  error_dec("Illegal window ", wNumber);
	 }
  return;
}

void TWindFile::DisplayOnly(char *buf, short wNumber)
{ windowNumber = wNumber; // Display will await painting at end of function
  switch (wNumber)
	{case 0 :
	 case 2 : if (w.no_display_or_file) return;
				 if (!w.jumping) cout << buf;
				 else buf[0] = '\0';
				 return;
	 case 1 : clrscr();
				 cout << buf;
				 return;
	 default: cout << buf;
				 sprintf(wf->wBuf, "Illegal window %d  Hit Key to Continue", wNumber);
				 cout << wf->wBuf << endl;
				 getch();
	 }
 return;
}

void TWindFile::FileOnly(char *buf) // , short wNumber)
{ if (w.no_display_or_file) return;
  if (w.diag) CopyBufToFile(File->Main, buf);
  else        CopyBufToBigBuf(buf);
}

void TWindFile::Initialize()
{ w.stage = 1;
  w.filechar = 'v' + 1;  // 1 is removed at start of world_data()
  w.jumpStep = 0;
  w.min_file_record_while_jumping = FALSE;
  LoopControl();
}

void TWindFile::LoopControl()
{while ( w.stage < 100 )             // || ( errorFlag == TRUE ))
	{ppCycleStages(w.stage); 
	}
 wf->CopyBigBufToFile();
 cout << "Hit Key to Exit." << endl;
 getch();
 exit(-1);
 return;
}

void TWindFile::ppCycleStages(short stge)  // from run_fm  p.52
{ int selection = 0;
  char ch;
  switch (stge)
	{case 0:
	 case 1:		world_data();
					w.stage =2; break;
	 case 2:    init_actions_stim();
				w.robot = 'B';
				s = sb; robot_data();   // initialized robot pointed to by sb
				w.robot = 'A';
				s = sa; robot_data();   // initialized robot pointed to by sa
				pp_data();                     // initialized robot A as PP
				if ( w.jumping )
				  {w.stage = 3; break;
				  }
				else
				  {// draw_board();
				   w.stage = 9; break;
				  }
	 case 3:    new_step_HN();							// in ppcycle.cpp
				get_actions_HN();
//				if ( s->mode == T_T ){ w.stage = 5; break; }
				swap_robot();  // 10sep99 Put here so latest stim for action
				if (w.robot == 'B') {w.stage = 10; break;}
				if (pp->not_learning) {w.stage = 6; break;}
				if (w.diag & 1) display_event_structure(AC);  // Robot A
	 case 4:
	 case 5:    if ((s->resource_f > w.sublevel) && (s->resource_d > w.sublevel))
                   start_or_not_tandt();
			  	if ( s->mode == T_T ){ w.stage = 13; break; }
	 case 6:    if ((!w.no_display_or_file) && ( s->mode == H_N ))
				  {clrscr();
				   display_board();
				  }
				get_stimuli_HN();            // in ppaction.cpp
				if (w.diag & 1) display_event_structure(ST); // Robot A
				if (pp->not_learning) {w.stage = 8; break;}
                update_ltmA();
				update_ltmS();       // Robot A, H_N
				pp->lkbk_flag =  OFF;
				w.stage = 7; break;
	 case 7:    leakback();
				if (pp->lkbk_flag) {w.stage = 7; break;} // Leakback not finished
//				w.stage = 8; break;
	 case 8:    shift_stm();        			// shift events
				if ( s->mode == T_T) { w.stage = 11;  break; }
			  //		if ( s->step > w.step_for_restart_with_different_file_name )
			  //		  {w.jumping = TRUE;
			  //			w.stage = 1;  break;   // Start a new run with different seed.
			  //		  }
				if ( w.jumpStep > s->step )
				  {w.jumping = TRUE;
				   w.stage = 3;  break;
				  }
				else {w.jumping = FALSE;
                      w.no_display_or_file = FALSE;
                     } 
//					w.stage = 9; break;  // To get display updated before options.
	case 9:     if (w.robot == 'A') wf->DisplayAndFile("\nRobot A, Select Option:",0);
                else wf->DisplayAndFile("\nRobot B, Select Option:",0);
                cout << "\nC to Continue." << endl;
                cout << "E to Display Event Structure." << endl;
                cout << "L to Display LTM tree (Contexts)." << endl;
                cout << "N to Display Nodes." << endl;
                cout << "A to Display Action Memory Arrays." << endl;
                cout << "S to Display Stimulus Memory Arrays." << endl;
                cout << "D to Set Diagnostics." << endl;
                cout << "P to Display Steps at which Rewarded Plans made." << endl;
                cout << "G to Display Graph of results." << endl;
                cout << "F to Min/Max to File (Toggle)." << endl;
                cout << "J to Jump to Step." << endl;
                cout << "H to Halt." << endl;
				selection = getch();
//                    if (ch == '\n') ch = '0';
				switch (selection)
					 {case 'c' :
                      case 'C' : w.stage = 3; break;      // Continue
                      case 'e' :
					  case 'E' : display_event_structure(BOTH); w.stage = 9; break;
                      case 'l' :
					  case 'L' : display_ltm_tree(); w.stage = 9; break;
                      case 'n' :
					  case 'N' : display_nodes(); w.stage = 9; break;
                      case 'a' :
  					  case 'A' : display_arrays_A(); w.stage = 9; break;
                      case 's' :
  					  case 'S' : display_arrays_S(); w.stage = 9; break;
                      case 'd' :
					  case 'D' : SetDiagnostics(); w.stage = 9; break;
                      case 'p' :
					  case 'P' : display_plan_steps(); w.stage = 9; break;
                      case 'g' :
					  case 'G' : display_extra_graph_line(); w.stage = 9; break;
                      case 'f' :
					  case 'F' : ToggleFile(); w.stage = 9; break;
                      case 'j' :
					  case 'J' : SetJump(); w.stage = 9; break;
                      case 'h' :
					  case 'H' : Terminate(); break;    // Halt carefully.
					  default: w.stage = 9;
					 }
				break;
	 case 10:   if (!w.jumping)
                  {clrscr();
                   draw_board();               // Robot B
                  }
				get_stimuli_HN();            // in ppaction.cpp
				shift_stm();        			// shift events
				if ( w.jumpStep > s->step )
				  {w.jumping = TRUE;
				   w.stage = 3;  break;
				  }
				else w.jumping = FALSE;
				w.stage = 9; break;
// These stages are for T&T:
	 case 11:   new_step_TT();			// T&T only
				get_actions_TT();
				w.stage = 12; break;
	 case 12:   end_or_not_tandt(); 	// in ppplans.cpp
				if ( s->mode == H_N ){ w.stage = 6; break; }
	 case 13:   get_stimuli_TT();          // T&T
				if (pp->t_t_termination == ON) {w.stage = 12; break;}  // to H&N
				w.stage = 14; break;    // skip to shift_stm if T_T
	 case 14:   shift_stm();        			// shift events
				w.stage = 11;  break;
	 default:   w.stage = 100; break;
	}
  return;
}

void TWindFile::Terminate()
{ int reply;
  cout << "\nPress Y to confirm that you want to HALT." << endl;
  cout << "Press any other key to return to options.";
  reply = getch();
  if (( reply == 'y' ) || ( reply == 'Y' )) w.stage = 100;
  else w.stage = 9;
  return;
}

// Diagnostic Printing is controlled by the bits of w.diag
void TWindFile::SetDiagnostics()
{ int selection;
  cout << "0 No diagnostics" << endl;
  cout << "1 STM diagnostics" << endl;
  cout << "2 LTM diagnostics" << endl;
  cout << "3 Leakback diagnostics" << endl;
  cout << "4 Plan diagnostics" << endl;
  cout << "5 World diagnostics" << endl;
  cout << "6 ALL diagnostics" << endl;
  selection = getch();
//  if (selection == '\n') selection = 0;
  switch (selection)
	  {case '0': w.diag = 0; break;      // Reset Print List
	   case '1': w.diag |= 1; break;     // STM Diagnostics
	   case '2': w.diag |= 2; break;     // LTM Diagnostics
	   case '3': w.diag |= 4; break;     // Leakback Diagnostics
	   case '4': w.diag |= 8; break;     // Plan Diagnostics
	   case '5': w.diag |= 16; break;    // World Diagnostics
 	   case '6': w.diag |= 63; break;    // All Diagnostics
	   default: w.diag = 0; }
  sprintf(wf->wBuf,"\nDiagnostics = %X ", w.diag);
  wf->DisplayAndFile(wf->wBuf, 0);
  return;
}

  // Sets w.jumpStep
void TWindFile::SetJump()       // Only with autofeed if tchr needed.
{ long choice;
  cout << "\nEnter step to jump to" << endl;
  cin >> choice;
  if (choice >= 0) w.jumpStep = choice;
  else {cout << "Must be zero or greater." << endl; return;}
  if  ( w.jumpStep > s->step )   //    && ( w.autofeed ) )
	 {sprintf(wf->wBuf,"\nJumping to step %d\n", w.jumpStep);
	  wf->DisplayAndFile(wf->wBuf, 1);
	  w.jumping = TRUE;
	 }
  else
	 {sprintf(wf->wBuf,
				  "\nStep is %d, Can't jump to step %d ", s->step, w.jumpStep);
	  wf->DisplayAndFile(wf->wBuf, 1);
	  w.jumping = FALSE;
	 }
  return;
}

void TWindFile::ToggleFile() // Outputting to file during jumping or not.
{ if (w.min_file_record_while_jumping )
	 {w.min_file_record_while_jumping = FALSE;
	  cout << "\nWill Output to File during Jumping." << endl;
	 }
  else {w.min_file_record_while_jumping = TRUE;
		cout << "\nMinimum Output to File during Jumping." << endl;
	   }
}


