// ppltms.cpp     PURRPUSS   Dev.from C.B.Gunn 22/4/93   jha:11aug98-9jun01
//  1feb01 Forgetting done properly.

#include "c:\Program Files\Borland\CBuilder3\examples\foodrink\ppheader.hpp"

extern robot_info *s;
extern pp_info *pp;
extern world w;
extern TWindFile	*wf;
extern char *event_type_names[];     // in ppworld.cpp
extern char *template_names[];       // in ppworld.cpp
extern char *cluster_namesS[];        // in ppworld.cpp
extern char *stream_names[];         // in ppworld.cpp


// ***** FUNCTION: update_ltmS() *****
void update_ltmS()
{ short cl, k, n, cnode, ttemp, prtyp;
  short valid_context;
//  struct nodeS *c_cntxtptr;
  struct event_type current_event;
  struct cluster_struct_S *clstrclS;
  if (!w.no_display_or_file) wf->DisplayAndFile("\n", 2);
  for (cl=0; cl<pp->nsclusters; cl++)                  // for each cluster
	 {valid_context = 0;
      clstrclS = &pp->clustersS[cl];
	  for (k=0; k < clstrclS->ntemps; k++)  // for each template in cluster
		 {ttemp = clstrclS->tem[k];
		  if ( pp->templates[ttemp].acst != ST ) continue;  // not equals!
		  if ( w.diag & 2 )
			{sprintf(wf->wBuf,"\nUpdating clusterS %s,temp %d,npreds:%d ",
								 cluster_namesS[cl],ttemp,pp->templates[ttemp].npreds);
			 wf->DisplayAndFile(wf->wBuf, 2);
			}
		  for (n=0; n<pp->templates[ttemp].npreds; n++)  //for each type of pred
			 {prtyp = pp->templates[ttemp].predict_event_type[n];
			  if ( w.diag & 2 )
				{ sprintf(wf->wBuf," prtyp=%d ",prtyp);
				  wf->DisplayAndFile(wf->wBuf, 2);
				}
			  if (((s->events[prtyp].tim == TRUE) &&
                             (s->events[prtyp].tim_shift_reg[0] == NULLEVENT))
                  || ((s->events[prtyp].thr == TRUE) &&
                             (s->events[prtyp].thr_shift_reg[0] == NULLEVENT)))
                 continue;
			  cnode = tree_searchS_plus( ttemp );  // >>> TREE_SEARCH_PLUS
			  if ( cnode == NULLNODE ) continue;
			  else
				{if ( w.diag & 2 )
				  {sprintf(wf->wBuf,"\ntree searchS+ succeeds for temp %d ",ttemp);
					wf->DisplayAndFile(wf->wBuf, 2);
				  }
		// We now have an context in which to store the prediction
				 valid_context = 1;
                 if (s->events[prtyp].tim == TRUE)
				   current_event.event = s->events[prtyp].tim_shift_reg[0];
                 if (s->events[prtyp].thr == TRUE)
				   current_event.event = s->events[prtyp].thr_shift_reg[0];
				 current_event.type = prtyp;
				 if ( w.diag & 2 )
				  {sprintf(wf->wBuf,"\nUpdating temp%d,clstr%d with typ%d,evt%X ",
						ttemp, cl, current_event.type, current_event.event);
					wf->DisplayAndFile(wf->wBuf, 2);
				  }
				 update_nodeS( cl, ttemp, cnode, current_event.type,
															 current_event.event );
				 clstrclS->last_event.event =  current_event.event;
				 clstrclS->last_event.type  =  current_event.type;
				 clstrclS->last_node      =  cnode;
				 break;  // No need to consider more than one prediction type
				}
			 }   //4}
		  if ( valid_context ) break;     // No need to consider more than one template
		 }      //3}   end of template loop
	 }         //2}   end of cluster loop
}             //1}

// ***** FUNCTION: update_nodeS() *****
// USED BY: update_ltmS().
// DESCRIPTION: Does all updating of current context.
//  templates[].kindofpred = CHOICE means can have list of predictions.
//								 RECENCY means only most recent prediction.
// NOTE: If more than one pred type, RECENCY can have one of each ??? No.
//                           ----BUT MORE THAN ONE PRED TYPE?!
void update_nodeS(short cluster, short temp, short  cnode,
															short c_type, long c_event)
{// struct nodeS    *l_cntxtptr;
//  struct lnode_pointers  *lnptr;
  struct predictionS     pred;
  struct cluster_struct_S *clstrclS;
  long pei, peiS ;
  short  flag = 0;
//  short  lnode, hold1_node, hold2_node;
  if (cnode == NULLNODE) error("\nupdate cntxtS: cnode is null ");
  clstrclS = &pp->clustersS[cluster];
  pei = clstrclS->assS[cnode].pei;
  if (pei >= pp->maxpredS[cluster] ) error_dec("\n**ucS*pei exceeds max preds ",pei);
//  if (cluster == CLLM)          // In Landmark cluster remove
//	 {remove_LMpreds_without_landmark(cnode);
//	  pei = clstrclS->assS[cnode].pei; // In case it has changed
//	 }
  if ( pei == NULLLONG )
	 {pei = clstrclS->assS[cnode].pei = newpredictionS(cluster, cnode);
		if ((pei == NULLLONG) || (pei >= pp->maxpredS[cluster]))
			error_dec("\n**ucS2*pei is null or exceeds max preds ",pei);
	  flag = 1;
	 }
  else if ( pp->templates[temp].kindofpred == CHOICE )  //look further if CHOICE
	 {flag = 2;
	  pred = clstrclS->prdS[pei];
//      wf->DisplayAndFile("\n***flag = 2. ", 2);
		while (((pred.event.event != c_event) || (pred.event.type != c_type ))
													&& (pred.next != NULLLONG))
		  {pei = pred.next;
			  if ((pei == NULLLONG) || (pei >= pp->maxpredS[cluster]))
				  error_dec("\n**ucS3*pei is null or exceeds max preds ",pei);
			  if (w.diag & 2)
				{sprintf(wf->wBuf, "\n***pei=%d ", pei);
				wf->DisplayAndFile(wf->wBuf, 2);
				}
			pred = clstrclS->prdS[pei];
		  }
// Exits while if either match or no more predictions or both
// Only if there is no match, do we need a new prediction.
	  if ( pred.event.event != c_event  ||  pred.event.type != c_type )
		 {flag = 3;
//          wf->DisplayAndFile("\n***flag = 3. ", 2);
		  pei = clstrclS->prdS[pei].next = newpredictionS(cluster, cnode);
			 if ((pei == NULLLONG) || (pei >= pp->maxpredS[cluster]))
				 error_dec("\n**ucS4*pei is null or exceeds max preds ",pei);
//		  wf->DisplayAndFile("\nNo match. ", 2);
		 }
	 }  // If flag == 1 or 3, we have a new prediction.
		 // If flag == 2, we have a match for CHOICE.
		 // If flag == 0 we have a match or no-match for RECENCY
  if ( w.diag & 2 )
	{sprintf(wf->wBuf, "  flag=%d ", flag);
	 wf->DisplayAndFile(wf->wBuf, 2);
	 }
  if ( (flag == 1) || (flag == 3) )		// first or later new prediction
		 {clstrclS->prdS[pei].event.event = c_event;     // PEI for c_event
		  clstrclS->prdS[pei].event.type  = c_type;
		  if (w.diag & 2)
			 {sprintf(wf->wBuf, "\nNew predtyp=%d,evt=%X for ",
														c_type, c_event);	// Yes
			  wf->DisplayAndFile(wf->wBuf, 2);
			  display_node(cnode, clstrclS->assS[cnode].temp, 2);
			 }
		  s->frustration = 0;
		  s->boredom = 0;
//        wf->DisplayAndFile("*****Boredom zeroed in ltmS", 2);
		  if (flag == 1)    // new first prediction
			 {clstrclS->assS[cnode].age = w.quantum;
			 }
		  else
			  clstrclS->assS[cnode].age += w.quantum; // expn stays till leakback calcs
		  clstrclS->prdS[pei].age = w.quantum;
		 }
// if there is a matching event and type:
  if ( flag == 2 ) 		// matching event and type for CHOICE
	 {clstrclS->assS[cnode].age += w.quantum;   // Add a quantum to age
	  clstrclS->prdS[pei].age += w.quantum;       // Add a quantum to prediction age
	 }
// Match or no match for RECENCY
  if (flag == 0)   // At this point   peiptr = c_cntxtptr->pei;
	{if ( pred.event.event != c_event  ||  pred.event.type != c_type )
	  {clstrclS->prdS[pei].event.event = c_event;		// no match
		clstrclS->prdS[pei].event.type  = c_type;
		clstrclS->assS[cnode].age = w.quantum;
		clstrclS->prdS[pei].age = w.quantum;
	  }
	 else		// match for RECENCY
	  {clstrclS->assS[cnode].age += w.quantum;
		clstrclS->prdS[pei].age += w.quantum;
	  }
	}
}

/******************************
// Removes preds of a specified nodeS which don't have a current landmark.
// If all preds are removed by this routine, update_nodeS() will add
// a new prediction so the node doesn't have to be removed.
void remove_LMpreds_without_landmark(short nodeS)
{ short nodeA;
  short count = -1; // used to say when assS[nodeS].pei is moved up.
  long peiA, peiS, last_peiS, empty_peiS;
  unsigned long bodyeye;
  struct predictionA *predptrA;
  struct predictionS *predptrS, *last_predptrS;
  struct cluster_struct_S *clustptrS;
  struct cluster_struct_A *clustptrA;
  if (w.diag & 2)
   {sprintf(wf->wBuf, "\nRemoving LMpreds without landmark from nodeS %d ", nodeS);
    wf->DisplayAndFile(wf->wBuf, 0);
   }
  clustptrA = &pp->clustersA[CLBE];
  clustptrS = &pp->clustersS[CLLM];
  peiS = clustptrS->assS[nodeS].pei;
  if (peiS >= pp->maxpredS[CLLM] ) error_dec("\n**LMremov*pei exceeds max preds ",peiS);
  while (peiS != NULLLONG)
	{count++;               // becomes 0 for preds deleted from first
	 predptrS = &clustptrS->prdS[peiS];
	 nodeA = (predptrS->event.event >> 16) & 0X0000FFFF;
	 bodyeye = predptrS->event.event & 0X0000FFFF;
	 if (nodeA > pp->clustersA[CLBE].highest_node) error_dec("\nLandmark node too large ", nodeA);
	 if (w.diag & 2)
		{sprintf(wf->wBuf, "\nLandmark nodeA=%d,bodyeye=%x ",nodeA, bodyeye);
		 wf->DisplayAndFile(wf->wBuf, 2);
		}
     if (nodeA != NULLNODE)
	  {peiA = clustptrA->assA[nodeA].pei;
	   while (peiA != NULLLONG)
	    {predptrA = &clustptrA->prdA[peiA];
		 if (predptrA->event.event == bodyeye)
          {if ((w.diag & 2) && ((predptrA->landmark) & s->drive))
              wf->DisplayAndFile(" ***LM ", 2);
           break;
          }
		 peiA = predptrA->next;
	    }
// peiA is NULLLONG or bodyeye is matched
	   if ((peiA != NULLLONG)  // so that rest is skipped if predptrA not defined
		  && (predptrA->event.event == bodyeye)
          && ((predptrA->landmark) & s->drive))
	    {last_peiS = peiS;
		 peiS = predptrS->next;
		 continue;  // Landmark is OK so continue with first "while"
	    }
      }
// Landmark false or prediction gone, so remove prediction event.
	 if (w.diag & 2)
		{sprintf(wf->wBuf, "\nRemoving peiS=%d, ", peiS);
		 wf->DisplayAndFile(wf->wBuf, 2);
		}
// As soon as one pred is kept, count exceeds 0 and assS[nodeS].pei can be left
// pointing to that first undeleted prediction.
	 if (count) last_predptrS = &clustptrS->prdS[last_peiS]; // corrected 23mar01
	 empty_peiS = clustptrS->empty_prdS_list;
	 clustptrS->empty_prdS_list = peiS;   // Point empty to new pred
//	 last_peiS = peiS;  // No! Don't move this up to empty pred.
	 if (!count) clustptrS->assS[nodeS].pei = peiS = predptrS->next;
	 else last_predptrS->next = peiS = predptrS->next; // branch over removed pred
	 predptrS->next = empty_peiS;       // connect removed pred to empty list
     clustptrS->assS[nodeS].age -= predptrS->age;
     if (clustptrS->assS[nodeS].age < 0)
        error_dec("Negative age of nodeS ",nodeS);
	 predptrS->age  = 0;                // zero removed pred
	 predptrS->event.type  = NULLTYPE;
	 predptrS->event.event = NULLEVENT;
	 count--; // So count remains zero if no prediction has a valid landmark
	}
}
************************/

// ***** FUNCTION: tree_searchS() *****
// USED BY: make_choice_s_list().
// DESCRIPTION: Searches given template LTM for a context matching STM. (?)

short  tree_searchS(short ntemp) // Differs from tree_searchA
{ short j, noTypes, node, cluster;                                     // right at end!
  unsigned long tevent;
  struct context_link *clptr, *testptr;
  long ctxel, testel;
  if (w.diag & 8) wf->DisplayAndFile("\ntree_searchS", 2);
  cluster = pp->templates[ntemp].clust;
  ctxel = pp->templates[ntemp].base;
  if ( ctxel == NULLLONG ) return( NULLNODE );               // very first entry
  clptr = &pp->clustersS[cluster].ctxtS[ctxel];
  noTypes = pp->templates[ntemp].noEvTypesInContext;
  for (j=0; j < noTypes; j++)  // for all levels
	 {tevent = (unsigned long) get_tim_regul(ntemp, j);
	  if (w.diag & 8)
		  {sprintf(wf->wBuf, " tevent=%X", tevent);
			wf->DisplayAndFile(wf->wBuf, 2);
		  }
	  if ( tevent == NULLEVENT  ) return( NULLNODE );
	  while ((clptr->event.event != tevent) && (clptr->next != NULLLONG))
			 {ctxel = clptr->next;
			  clptr = &pp->clustersS[cluster].ctxtS[ctxel];
              testel = clptr->linkbk;
              if (testel == NULLLONG) error_dec("\nNo link back for ctxel ",ctxel);
              testptr = &pp->clustersS[cluster].ctxtS[testel];
              if ((testptr->next != ctxel) && (testptr->next_list != ctxel))
                 error_dec("\n**tsS*linkbk doesn't point to ctxel ", ctxel);
			 }
	  if ( clptr->event.event != tevent ) return( NULLNODE ); // no match
	  if (j < (noTypes-1))
		 if (clptr->next_list != NULLLONG)
			{ctxel = clptr->next_list;
			 clptr = &pp->clustersS[cluster].ctxtS[ctxel];
             testel = clptr->linkbk;
             if (testel == NULLLONG) error_dec("\nNo link back for ctxel ",ctxel);
             testptr = &pp->clustersS[cluster].ctxtS[testel];
             if ((testptr->next != ctxel) && (testptr->next_list != ctxel))
                error_dec("\n**tsS2*linkbk doesn't point to ctxel ", ctxel);
			}
		 else return( NULLNODE ); // incomplete match
	  if (j == (noTypes-1)) node = (short)clptr->next_list;
	 }
  if ((w.diag & 8) && (node != NULLNODE))
								wf->DisplayAndFile(" tree_searchS succeeds\n", 2);
  return ( node );
}

// ***** FUNCTION: tree_searchS_plus() *****
// USED BY: update_ltmS().
// DESCRIPTION: Searches given template LTM for a context matching STM.
//      Creates tree path, and context if they do not exist.
short tree_searchS_plus(short ntemp) // Differs from
{ short j, noTypes, cluster, cycle_counter;
  short flag = 0;
  short node = NULLNODE;
  noTypes = pp->templates[ntemp].noEvTypesInContext;
  cycle_counter = noTypes * 2;
  cluster = pp->templates[ntemp].clust;
  if ( w.diag & 2 )
	{sprintf(wf->wBuf,"\nTree search+ temp=%s,%d types in ctxt ",
					template_names[ntemp],noTypes);
	 wf->DisplayAndFile(wf->wBuf, 2);
	 }
  for (j=0; j<noTypes; j++)             // Check that context is in the STM.
	  if (get_tim_regul(ntemp, j) == NULLEVENT) {flag = 1; break; }
  if ( flag == 1 ) return( NULLNODE );  // Context not in STM
  if (w.diag & 2) wf->DisplayAndFile("\nContext is in STM.", 2);
  while ((node == NULLNODE) && (cycle_counter--))
		 {node = make_context_without_removing_nodesS(cluster,ntemp,noTypes);
		 }
  if (node == NULLNODE) error("Failed to create context without removing nodeS.");
  else return( node );
}

// Returns for re-make if link or node has to be removed.
short make_context_without_removing_nodesS(short cluster, short ntemp,
				   									short noTypes)
{ short j, prtyp, cycle_counter, flag;
  short node = NULLNODE;
  unsigned long tevent;
  struct context_link *clptr, *testptr;
  long ctxel, backel, emptyel;
  ctxel = pp->templates[ntemp].base;
  backel = NULLLONG;  // Indicates pointing back to base
// If base is NULLLONG, then point root at new link.
  if ( ctxel == NULLLONG )
	 {flag = FALSE;
      if (pp->clustersS[cluster].empty_ctxtS_list == NULLLONG)
        flag = TRUE;
      ctxel = newcontext_linkS(cluster);
      if (ctxel == NULLLONG) error("\nmcwrnS:No new ctxt link");
	  if (flag)
         {emptyel = pp->clustersS[cluster].empty_ctxtS_list;
          pp->clustersS[cluster].empty_ctxtS_list = ctxel;
          pp->clustersS[cluster].ctxtS[ctxel].next = emptyel;
          return( NULLNODE ); // minus if node removed
         }
	  pp->templates[ntemp].base = ctxel;
	 }
  clptr = &pp->clustersS[cluster].ctxtS[ctxel];
  clptr->linkbk = backel;  // This is NULLLONG here
  for (j=0; j<noTypes; j++)                 // for all types in context
	 {tevent = get_tim_regul(ntemp, j);   // event of j'th
	  prtyp = pp->templates[ntemp].eventdeftype[j]; // type  of j'th
	  if ( w.diag & 2 )
		{sprintf(wf->wBuf," Stype %d,event=%X ", prtyp, tevent);
		 wf->DisplayAndFile(wf->wBuf, 2);
		}
	  if ( clptr->event.event == NULLEVENT )  // Event not on list. Empty
		{clptr->event.event = tevent;
		 clptr->event.type = prtyp;
		 if ( w.diag & 2 )
			 wf->DisplayAndFile("\n**Styp/ev inserted as first.", 2);
		}
	  else
		{while ( (clptr->next != NULLLONG) &&    // While no match & is another.
				  ((clptr->event.event != tevent) || (clptr->event.type != prtyp)))
			 {backel = ctxel;
			  ctxel = clptr->next;       // Look at the next
			  clptr = &pp->clustersS[cluster].ctxtS[ctxel];
			  clptr->linkbk = backel;
              testptr = &pp->clustersS[cluster].ctxtS[backel];
              if (testptr->next != ctxel)
                 error_dec("\n**mcwrnS1*linkbk doesn't point to ctxel ", ctxel);
			 }
		 if ((clptr->event.event != tevent) || (clptr->event.type != prtyp))
			 {backel = ctxel;
			  flag = FALSE;
              if (pp->clustersS[cluster].empty_ctxtS_list == NULLLONG)
                flag = TRUE;
              ctxel = newcontext_linkS(cluster);
              if (ctxel == NULLLONG) error("\nmcwrnS2:No new ctxt link ");
	          if (flag)
                {emptyel = pp->clustersS[cluster].empty_ctxtS_list;
                 pp->clustersS[cluster].empty_ctxtS_list = ctxel;
                 pp->clustersS[cluster].ctxtS[ctxel].next = emptyel;
                 return( NULLNODE ); // minus if node removed
                }
			  clptr->next = ctxel;
			  clptr = &pp->clustersS[cluster].ctxtS[ctxel];
			  clptr->event.event = tevent;     // and put the event,type in it
			  clptr->event.type = prtyp;
			  clptr->next =  NULLLONG;
			  clptr->next_list =  NULLLONG;
			  clptr->linkbk = backel;
              testptr = &pp->clustersS[cluster].ctxtS[backel];
              if (testptr->next != ctxel)
                 error_dec("\n**mcwrnS2*linkbk doesn't point to ctxel ", ctxel);
			  if ( w.diag & 2 )
				{sprintf(wf->wBuf, "\nNew linkS with typ=%d,event=%X ",
																			prtyp, tevent);
				 wf->DisplayAndFile(wf->wBuf, 2);
			    }
			}
		}    // At this point the event,type must have matched or been added.
	  if ((clptr->next_list == NULLLONG) && (j < (noTypes - 1))) //not last evt
		 {backel = ctxel;
		  flag = FALSE;
          if (pp->clustersS[cluster].empty_ctxtS_list == NULLLONG)
             flag = TRUE;
          ctxel = newcontext_linkS(cluster);
          if (ctxel == NULLLONG) error("\nmcwrnA3:No new ctxt link ");
	      if (flag)
            {emptyel = pp->clustersS[cluster].empty_ctxtS_list;
             pp->clustersS[cluster].empty_ctxtS_list = ctxel;
             pp->clustersS[cluster].ctxtS[ctxel].next = emptyel;
             return( NULLNODE ); // minus if node removed
            }
		  clptr->next_list = ctxel;
		  clptr = &pp->clustersS[cluster].ctxtS[ctxel];
		  clptr->linkbk = backel;
          testptr = &pp->clustersS[cluster].ctxtS[backel];
          if (testptr->next_list != ctxel)
             error_dec("\n**mcwrnS3*linkbk doesn't point to ctxel ", ctxel);
		  if ( w.diag & 2 )
					 {sprintf(wf->wBuf, "\nNew list link to ctxel=%d ", ctxel);
					  wf->DisplayAndFile(wf->wBuf, 2);
					 }
		 }
	  else if ((clptr->next_list != NULLLONG) && (j < (noTypes - 1))) // not last
			 {backel = ctxel;
			  ctxel = clptr->next_list;     // 18aug99        // and link exists
			  clptr = &pp->clustersS[cluster].ctxtS[ctxel];
			  clptr->linkbk = backel;
              testptr = &pp->clustersS[cluster].ctxtS[backel];
              if (testptr->next_list != ctxel)
                 error_dec("\n**mcwrnS4*linkbk doesn't point to ctxel ", ctxel);
				if ( w.diag & 2 )
					 {sprintf(wf->wBuf, "\nList link exists to ctxel=%d ",ctxel);
					  wf->DisplayAndFile(wf->wBuf, 2);
					 }
			 }
	  else if ((clptr->next_list == NULLLONG) && (j == (noTypes - 1))) //last evt
			 {flag = FALSE;
              if (pp->clustersS[cluster].empty_assS_list == NULLNODE)
                 flag = TRUE;  // Node will have to be removed to get new one.
              node = newnodeS(ntemp, NULLNODE); // No cnode yet
              if (node == NULLNODE) error("\nmcwrnS:No new node link ");
	          if (flag)
                {emptyel = pp->clustersS[cluster].empty_assS_list;
                 pp->clustersS[cluster].empty_assS_list = node;
                 pp->clustersS[cluster].assS[node].next = emptyel;
                 return( NULLNODE ); // minus if node removed
                }
			  clptr->next_list = (long) node;
			  clptr->linkbk = backel;
              testptr = &pp->clustersS[cluster].ctxtS[backel];
              if ((testptr->next != ctxel) && (testptr->next_list != ctxel))
                 error_dec("\n**mcwrnS5*linkbk doesn't point to ctxel ", ctxel);
			  pp->clustersS[cluster].assS[node].ctxtel = ctxel;  // 4jan01
			  pp->clustersS[cluster].assS[node].step_last_used = s->step;
				if ( w.diag & 2 )
					 {sprintf(wf->wBuf, "\nNew cntxt link to node=%d ",node);
					  wf->DisplayAndFile(wf->wBuf, 2);
					 }
			 }
	  else if ((clptr->next_list != NULLLONG) && (j == (noTypes - 1))) //last evt
			 {node = (short)clptr->next_list;     // 18aug99 // and context exists
				  pp->clustersS[cluster].assS[node].step_last_used = s->step;
				if ( w.diag & 2 )
					 {sprintf(wf->wBuf, "\nCntxt link exists to node=%d ",node);
					  wf->DisplayAndFile(wf->wBuf, 2);
					 }
				 }
	 }   // repeat the above until the context processed.
  if (!w.no_display_or_file)
	 {sprintf(wf->wBuf," %d%s%s", node, pp->templates[ntemp].tname,
								 cluster_namesS[pp->templates[ntemp].clust]);
	  wf->DisplayAndFile(wf->wBuf, 2);
	 }
  return ( node );
}

