// ppplans.cpp    PURRPUSS   Dev.from C.B.Gunn 22/4/93    jha: 13aug98-26jly01

#include "c:\Program Files\Borland\CBuilder3\examples\foodrink\ppheader.hpp"

extern robot_info *s;
extern pp_info *pp;
extern world w;
extern TWindFile	*wf;

// *****  FUNCTION: start_or_not_tandt()  *****
void start_or_not_tandt()
{ // struct choice_listS *planptr;      // *tplanptr;
  struct choice_S *adrchS;
  short strm;
  short preds_for_all_S_streams = TRUE;           // k,n,stream;
  if (w.diag & 8) wf->DisplayAndFile("\nstart-or-not-tt: ", 2);
//  if (pp->t_t_termination == ON) {stay_in_or_restore_h_n(); return; } 	// here
// Predict stimuli for h&n or t&t.
  wipe_choice_listsS();
  for (strm=s->nastreams; strm<s->nstreams; strm++)  // only stimulus streams
	 {wipe_best_predsS(strm);
	  pp->rest_choice_list_S[strm].index_best = -1;
	  pp->rest_choice_list_S[strm].rest_worth = NULLWORTH;
	  make_choice_listS(strm);
	 }
// Divided into two so that choice can be repeated for next choices if
// stimuli don't give a context for an action prediction.  2mar00   <<<<<<
  for (strm=s->nastreams; strm<s->nstreams; strm++)  // only stimulus streams
	 {adrchS = choose_best_from_listS(strm);
	  if ( adrchS->event.event == NULLEVENT )   // No Best
		{s->predicted_stimulus[strm].event = NULLEVENT;
		 s->predicted_stimulus[strm].type  = NULLTYPE;
         if (strm != DESTR)    //  && (strm != LMSTR)
           {if (w.diag & 8)
              wf->DisplayAndFile("\nNot preds for all S streams. ", 2);
			preds_for_all_S_streams = FALSE;
		   }
        }
	  else
		{s->predicted_stimulus[strm].type  = adrchS->event.type;  // replaces
		 s->predicted_stimulus[strm].event = adrchS->event.event; // etcopy()
		 add_to_best_listS(strm, adrchS); // Copy best onto best preds list
		}
	 }
// Don't leave h&n if still following path.
//  if ( s->mode == H_N ){
  pp->path_steps_to_go--;
  pp->path_step++;
  if ( pp->path_steps_to_go > 0  &&  pp->marks_seen > 0 )
    {if (!w.no_display_or_file)
       {sprintf(wf->wBuf," %d to follow ",pp->path_steps_to_go);
	    wf->DisplayAndFile(wf->wBuf, 0);
       }
     pp->marks_seen = 0;
	}
// Unless no marks seen: in which case stop following path and wipe marks.
  else {if (pp->path_steps_to_go == 0)
		  {if (pp->path_length > 2)
			 {if (!w.no_display_or_file)
                {sprintf(wf->wBuf,"\n%d step Path followed ",
						                 	        pp->path_length);
				 wf->DisplayAndFile(wf->wBuf, 0);
                }
			  pp->paths_longer_than_2_followed++;    // Paths of length >2
			 }
		   pp->path_length = 0;
		   pp->path_step = -1;
		  }
// With path not being followed, either because it has ended or no marks seen,
// wipe all marks and attempt to start t&t.
		pp->path_steps_to_go = -1;
		pp->marks_seen = 0;
		wipe_all_marks();	// in pppred.cpp
		if ( preds_for_all_S_streams )
		  {wf->DisplayAndFile("\nT+T now. ", 2);
		   install_t_t();
	   }
  }
}

// *****  FUNCTION: end_or_not_tandt()  *****
void end_or_not_tandt()
{ // struct choice_listS *planptr;      // *tplanptr;
  struct choice_S *adrchS;
  short strm;
  short preds_for_all_S_streams = TRUE;           // k,n,stream;
//   short test_TT_for_stream_says_terminate = FALSE;
  if (w.diag & 8) wf->DisplayAndFile("\nend-or-not-tt: ", 2);
  if (s->step >= MAX_PLAN_LENGTH) pp->t_t_termination = ON;
  if (pp->t_t_termination == ON) {stay_in_or_restore_h_n(); return; } 	// here
// Predict stimuli for h&n or t&t.
  wipe_choice_listsS();
  for (strm=s->nastreams; strm<s->nstreams; strm++)  // only stimulus streams
	 {wipe_best_predsS(strm);
	  pp->rest_choice_list_S[strm].index_best = -1;
	  pp->rest_choice_list_S[strm].rest_worth = NULLWORTH;
	  make_choice_listS(strm);
	 }
// Divided into two so that choice can be repeated for next choices if
// stimuli don't give a context for an action prediction.  2mar00   <<<<<<
  for (strm=s->nastreams; strm<s->nstreams; strm++)  // only stimulus streams
	 {adrchS = choose_best_from_listS(strm);
		 if ( adrchS->event.event == NULLEVENT )   // No Best
			{s->predicted_stimulus[strm].event = NULLEVENT;
			 s->predicted_stimulus[strm].type  = NULLTYPE;
             if (strm != DESTR)     // && (strm != LMSTR)
			   preds_for_all_S_streams = FALSE;
			}
		 else
			{s->predicted_stimulus[strm].type  = adrchS->event.type;  // replaces
			 s->predicted_stimulus[strm].event = adrchS->event.event; // etcopy()
			 add_to_best_listS(strm, adrchS); // Copy best onto best preds list
			 s->events[adrchS->event.type].tim_shift_reg[0] = adrchS->event.event;
			}
	 }
	 if (w.diag & 8) display_best_predictionsS();
	 copy_list_pred_to_current();	// predicted_stimulus to current_stimulus
	 if ( !preds_for_all_S_streams )
		 {wf->DisplayAndFile("\nNot all preds for T+T", 2);
		  pp->path_length = 0;
		  pp->path_step = -1;
		  wipe_all_marks();
		  stay_in_or_restore_h_n();       		// here in ppplans.cpp
		 }
}

// *****  FUNCTION: streams_have_pred_stim() not including DESTR  *****
// DESCRIPTION: Search pred-stim list and return TRUE if a pred is found.
//     Assumes that event 0 is "-" and type 0 is "-"
short streams_have_pred_stim()
{ short j;
  for (j=s->nastreams; j<s->nstreams; j++)
	  if ((j != DESTR)     // && (j != LMSTR)
        && (s->predicted_stimulus[j].event != NULLEVENT)
		  && (s->predicted_stimulus[j].type != NULLTYPE)) return( TRUE );
  wf->DisplayAndFile("  No predicted stimuli", 2);
  return( FALSE );    }

// *****  FUNCTION: install_t_t()  *****
void install_t_t()
{ short j, k;
  wf->DisplayAndFile("\n-->--> T+T", 2);
  s->mode = T_T;
  pp->hold.step = s->step;
  s->step = 0;
  pp->path_length = 0;
  for (j=s->nastreams; j<s->nstreams; j++)
	 {pp->hold.current_stimulus[j].type  = s->current_stimulus[j].type; //replaces
	  pp->hold.current_stimulus[j].event = s->current_stimulus[j].event;//etcopy()
	  s->current_stimulus[j].type  = s->predicted_stimulus[j].type;  // replaces
	  s->current_stimulus[j].event = s->predicted_stimulus[j].event; // etcopy()
	 }
  for (j=0; j<s->nastreams; j++)
	  {pp->hold.current_action[j].type  = s->current_action[j].type;  // replaces
		pp->hold.current_action[j].event = s->current_action[j].event; // etcopy()
		s->current_action[j].type  = s->predicted_action[j].type;     // replaces
		s->current_action[j].event = s->predicted_action[j].event;    // etcopy()
		pp->hold.current_expectation[j] = s->streams[j].current_expectation;
		pp->hold.last_expectation[j] = s->streams[j].last_expectation;
	  }
  for (j=0; j<s->nevtypes; j++)
	 {for (k=0; k<MAX_EVENT_SHIFTS; k++)
		{pp->hold.events[j].tim_shift_reg[k] = s->events[j].tim_shift_reg[k];
		 pp->hold.events[j].thr_shift_reg[k] = s->events[j].thr_shift_reg[k];
		}
	 }
	 for (j=0; j<pp->naclusters; j++)
		{pp->hold.clustersA[j].last_node = pp->clustersA[j].last_node;
		 pp->hold.clustersA[j].last_event.type = pp->clustersA[j].last_event.type;
		 pp->hold.clustersA[j].last_event.event= pp->clustersA[j].last_event.event;
		}
	 for (j=0; j<pp->nsclusters; j++)
		{pp->hold.clustersS[j].last_node = pp->clustersS[j].last_node;
		 pp->hold.clustersS[j].last_event.type = pp->clustersS[j].last_event.type;
		 pp->hold.clustersS[j].last_event.event= pp->clustersS[j].last_event.event;
		}
//c 	 for (j=0; j<CANVAS_SIZE; j++)
//c 		 {pp->hold.canvas[j] = pp->canvas[j];
//c 		  pp->hold.decay[j] = pp->decay[j];
//c 		 }
}

// *****  FUNCTION: stay_in_or_restore_h_n()  *****
void stay_in_or_restore_h_n()
{ short j, k;
  if ( s->mode == H_N ) return;
  wf->DisplayAndFile("\n=>>=>> h+n", 0);
  pp->t_t_termination == OFF;
  s->mode = H_N;
  s->step = pp->hold.step;
  for (j=s->nastreams; j<s->nstreams; j++)
	  {s->current_stimulus[j].type  = pp->hold.current_stimulus[j].type;//replaces
		s->current_stimulus[j].event = pp->hold.current_stimulus[j].event;//etcopy
	  }
  for (j=0; j<s->nastreams; j++)
	  {s->current_action[j].type  = pp->hold.current_action[j].type;  // replaces
		s->current_action[j].event = pp->hold.current_action[j].event; // etcopy()
		s->streams[j].current_expectation = pp->hold.current_expectation[j];
		s->streams[j].last_expectation = pp->hold.last_expectation[j];
	  }
  for (j=0; j<s->nevtypes; j++)
	 {for (k=0; k<MAX_EVENT_SHIFTS; k++)
		 {s->events[j].tim_shift_reg[k] = pp->hold.events[j].tim_shift_reg[k];
		  s->events[j].thr_shift_reg[k] = pp->hold.events[j].thr_shift_reg[k];}}
  for (j=0; j<pp->naclusters; j++)
	  {pp->clustersA[j].last_node = pp->hold.clustersA[j].last_node;
		pp->clustersA[j].last_event.type = pp->hold.clustersA[j].last_event.type;
		pp->clustersA[j].last_event.event= pp->hold.clustersA[j].last_event.event;
	  }
  for (j=0; j<pp->nsclusters; j++)
	  {pp->clustersS[j].last_node = pp->hold.clustersS[j].last_node;
		pp->clustersS[j].last_event.type = pp->hold.clustersS[j].last_event.type;
		pp->clustersS[j].last_event.event= pp->hold.clustersS[j].last_event.event;
	  }
//c   for (j=0; j<CANVAS_SIZE; j++)
//c 	  {pp->canvas[j] = pp->hold.canvas[j];
//c 		pp->decay[j] = pp->hold.decay[j];
//c 	  }
}

// *****  FUNCTION: test_for_tt_terminationA()  *****  FOR ONE STREAM 28aug99
short test_for_tt_terminationA(short stream)  // returns TRUE=1, FALSE=0
{ char novTerm = FALSE, disTerm = FALSE, loopTerm = FALSE, emptyTerm = FALSE;
  struct choice_A *adrchA;
//  struct node_linkA *bptr, *nptr;  // Nodes from predictions
  struct predictionA pred;
  long pei;
  short i, node, cluster, temp;
  if (w.diag & 8) wf->DisplayAndFile("\nTest_for_tt_termination. ", 2);
//1mar01  if (stream == SASTR) return( FALSE );
  if (stream >= s->nastreams) error("Not action stream for test.", stream);
  adrchA = &pp->best_predictionsA[stream];
  if (adrchA->event.event == NULLEVENT)
	 {if (w.diag & 8)
		 {sprintf(wf->wBuf, " No prediction for stream %d ",stream);
		  wf->DisplayAndFile(wf->wBuf, 2);
		 }
	  emptyTerm = TRUE;		// No predictions for stream
	 }
  else
	{disTerm = TRUE;	  // Falsified by prediction without dis.
	 for (i=0; i<MAX_NODES_PER_CHOICE; i++)
		{if ( adrchA->chnodesA[i].node == NULLNODE) break;
		 node = adrchA->chnodesA[i].node;
		 cluster = adrchA->chnodesA[i].cluster;
		 pei = pp->clustersA[cluster].assA[node].pei;
		 temp = pp->clustersA[cluster].assA[node].temp;
		 if ((w.diag & 8) && (pei != NULLNODE))
			{pred = pp->clustersA[cluster].prdA[pei];
			 sprintf(wf->wBuf," temp%d/pred.type%d/event=%d ",
								 temp, pred.event.type, pred.event.event);
			 wf->DisplayAndFile(wf->wBuf, 2);
			}
		 while (pei != NULLNODE)
			{pred = pp->clustersA[cluster].prdA[pei];
			 if ( !pred.disapproval )		// prediction without disapproval
				{ disTerm = FALSE;  // this stream not terminated by disapproval
				}
			 if (w.diag & 8)
				  {sprintf(wf->wBuf,"\nstrm=%d,pred.mark=%d,temp is in=%d ",
					  stream, pred.mark, pp->templates[temp].is_in_leakback_cluster);
					wf->DisplayAndFile(wf->wBuf, 0);
				  }
			 if ( ((pred.novelty == 1)
                     || ((s->drive & w.food) && (pred.novelty & w.food))
					 || ((s->drive & w.drink) && (pred.novelty & w.drink))
                     || ((!(s->drive & w.plus)) && (pred.novelty & w.good)) ) &&
					(!w.novelty_with_leakback_only
                       ||(w.novelty_with_leakback_only
                              && pp->templates[temp].is_in_leakback_cluster)))
				{novTerm = (char) pred.novelty; // terminated by novelty
				 pp->path_length = s->step;
				 if (s->step > 2) pp->tt_paths_longer_than_2++;
				 if (s->step > 5) pp->tt_paths_longer_than_5++;
				 if ((s->step > 3) && (pred.novelty > 1))
					pp->rewarded_plans[pp->last_rewarded_plan_number++]
                                                        = pp->hold.step;
				 if (pp->last_rewarded_plan_number >= MAX_REWARDED_PLANS)
					error("Exceeded MAX_REWARDED_PLANS.");
				 if (w.plans_remove_novelty)
					{if (pred.novelty == 1)
						{pp->clustersA[cluster].prdA[pei].novelty = 0;
						 s->boredom = 0;
						}
					}
				 s->frustration++;
				 if (w.diag & 8)
				  {sprintf(wf->wBuf,"\nT+T reaches novelty. strm=%d,frus=%d ",
																	 stream, s->frustration);
					wf->DisplayAndFile(wf->wBuf, 0);
				  }
				 display_node(node, pp->clustersA[cluster].assA[node].temp, 0);
				 pp->path_steps_to_go = s->step;
				 pp->path_step = 1; // Setting up for following plan
				 break;    // leave "while" loop and terminate
				}
			 if ((pred.mark == LOOPMARK) &&	// later step for loop   12mar00
										pp->templates[temp].is_in_leakback_cluster)
				{loopTerm = TRUE; // terminated by loop.
                 if (!w.no_display_or_file)
//				 if (w.diag & 8 )
				  {sprintf(wf->wBuf,"\nT+T loops:mark=%d,step=%d,stream=%d ",
                                      pred.mark, s->step, stream);
					wf->DisplayAndFile(wf->wBuf, 2);
					display_node(node, temp, 2);
				  }
				 s->boredom_inc = ON;  wf->DisplayAndFile(" ***Binc-loop", 0);
				 break;     // leave "while" loop and terminate
				}
			 pei = pred.next;
			}    // end of "while" loop
		 if (( loopTerm ) || ( novTerm )) break;
		}     //  end of "for" loop for node
	 if ((w.diag & 8) && emptyTerm )     // All List not empty
		{sprintf(wf->wBuf,"\nT+T ends by no predictions for stream=%d ", stream);
		 wf->DisplayAndFile(wf->wBuf, 2);
		}
	}          //  end of "else"
  if ( novTerm || disTerm || loopTerm || emptyTerm )
	 {if  ( disTerm || loopTerm || emptyTerm )
		  {pp->path_length = 0;
			pp->path_step = -1;
			wipe_all_marks();
		  }
	  if (!w.no_display_or_file)
	   {sprintf(wf->wBuf,"\nTT ends str%d:nov%d,dis%d,loop%d,empty%d",
			  			 stream, novTerm, disTerm, loopTerm, emptyTerm);
	    wf->DisplayAndFile(wf->wBuf, 0);
       }
	  return TRUE;
	 }
  else
	 {if (w.diag & 8)
		 {sprintf(wf->wBuf," T+T str%d OK", stream);
		  wf->DisplayAndFile(wf->wBuf, 2);
		 }
	  return FALSE;
	 }
}

// *****  FUNCTION: test_for_tt_terminationS()  *****  FOR ONE STREAM 28aug99
short test_for_tt_terminationS(short stream)  // returns TRUE=1, FALSE=0
{ char emptyTerm = FALSE;
//  struct node_linkS *bptr, *nptr;  // Nodes from predictions
  struct predictionS pred;
  struct choice_S *adrchS;
  long pei;
  short i, node, cluster, temp;
  if (w.diag & 8) wf->DisplayAndFile("\nTest_for_tt_terminationS. ", 2);
  adrchS = &pp->best_predictionsS[stream];
  if (adrchS->event.event == NULLEVENT)
	 {if (w.diag & 8)
		 {sprintf(wf->wBuf, " No prediction for stream %d ",stream);
		  wf->DisplayAndFile(wf->wBuf, 2);
		 }
	  emptyTerm = TRUE;		// No predictions for stream
	 }
  else
	 {for (i=0; i<MAX_NODES_PER_CHOICE; i++)
		{node = adrchS->chnodesS[i].node;
		 if (node == NULLNODE) break;
		 cluster = adrchS->chnodesS[i].cluster;
		 pei = pp->clustersS[cluster].assS[node].pei;
		 temp    = pp->clustersS[cluster].assS[node].temp;
		 if ((w.diag & 8) && (pei != NULLNODE))
			{pred = pp->clustersS[cluster].prdS[pei];
			 sprintf(wf->wBuf," temp%d/pred.type%d/event=%d ",
								  temp, pred.event.type, pred.event.event);
			 wf->DisplayAndFile(wf->wBuf, 2);
			}
		}     //  end of "for" loop for node
	  if ((w.diag & 8) && emptyTerm )     // All List not empty
		 {sprintf(wf->wBuf,"\nT+T ends by no predictions for stream=%d ", stream);
		  wf->DisplayAndFile(wf->wBuf, 2);
		 }
	 }          //  end of "else"
  if ( emptyTerm )
	 {pp->path_length = 0;
	  wipe_all_marks();
	  if (!w.no_display_or_file)
        {sprintf(wf->wBuf,"\nTT ends str%d:empty%d", stream, emptyTerm);
	     wf->DisplayAndFile(wf->wBuf, 0);
        }
	  return TRUE;
	 }
  else
	 {if (w.diag & 8)
		 {sprintf(wf->wBuf," T+T str%d OK", stream);
		  wf->DisplayAndFile(wf->wBuf, 2);
		 }
	  return FALSE;
	 }
}

// *****  Copies the predicted onto the current stimulus list.
void copy_list_pred_to_current()
{ short j;
  for (j=s->nastreams; j<s->nstreams; j++)    // stimulul streams
	 {s->current_stimulus[j].type  = s->predicted_stimulus[j].type;  // replaces
	  s->current_stimulus[j].event = s->predicted_stimulus[j].event; // etcopy()
	 }
}


